#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		lpadmin		lpadmin
#-----------------------------------------------------------------------------
Name		:	cups
Version		:	2.4.11
Release		:	17.2.3.rel%{?dist}
Summary		:	CUPS printing system
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2
URL		:	https://github.com/OpenPrinting/cups/

Source0		:	%{name}-%{version}-source.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	acl
BuildRequires	:	avahi
BuildRequires	:	dbus-devel
BuildRequires	:	gnutls
BuildRequires	:	libusb
BuildRequires	:	libpaper-devel
BuildRequires	:	pam-devel
BuildRequires	:	xdg-utils

Requires	:	chkconfig
Requires	:	%{name}-filters
Requires	:	%{name}-libs
Requires	:	dbus-daemon
Requires	:	lfs-bootscripts
Requires	:	nss-mdns
Requires(post)	:	shadow
Requires(post)	:	gtk3+

#-----------------------------------------------------------------------------
%description
CUPS printing system provides a portable printing layer for
UNIX® operating systems. It has been developed by Apple Inc.
to promote a standard printing solution for all UNIX vendors and users.
CUPS provides the System V and Berkeley command-line interfaces.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc CREDITS.md LICENSE README.md
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%dir %attr(0711,%{name},lp) %{_var}/spool/%{name}
%dir %attr(0755,root,lp) %{_sysconfdir}/%{name}/ppd
%dir %attr(0700,root,lp) %{_sysconfdir}/%{name}/ssl
%attr(0640,root,lp) %{_sysconfdir}/%{name}/cupsd.conf.default
%attr(0640,root,lp) %{_sysconfdir}/%{name}/snmp.conf.default
%attr(0640,root,lp) %{_sysconfdir}/%{name}/cups-files.conf.default
%config(noreplace) %attr(0640,root,lp) %{_sysconfdir}/%{name}/%{name}d.local
%config(noreplace) %attr(0640,root,lp) %{_sysconfdir}/%{name}/%{name}d.remote
%config(noreplace) %attr(0640,root,lp) %{_sysconfdir}/%{name}/cups-files.conf
%config(noreplace) %attr(0644,root,lp) %{_sysconfdir}/%{name}/snmp.conf
%config(noreplace) %attr(0644,root,lp) %{_sysconfdir}/dbus-1/system.d/%{name}.conf
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/pam.d/%{name}
%{_sysconfdir}/%{name}/%{name}d.conf
%{_sysconfdir}/xinetd.d/%{name}-lpd
%{_bindir}/%{name}*
%{_bindir}/cancel
%{_bindir}/ipptool
%{_bindir}/ippfind
%{_bindir}/ippeveprinter
%{_bindir}/lp*
%{_bindir}/ppd*
%{_sbindir}/%{name}*
%{_sbindir}/lpc
%{_sbindir}/lpadmin
%{_sbindir}/lpinfo
%{_sbindir}/lpmove
%{_libdir}/%{name}/*
%{_datadir}/locale/*/%{name}_*.po
%{_datadir}/%{name}/drv/*
%{_datadir}/%{name}/ppdc/*
%{_datadir}/%{name}/mime/*
%{_datadir}/%{name}/ipptool/*
%{_datadir}/%{name}/examples/*.drv
%{_datadir}/%{name}/templates/*/*.tmpl
%{_datadir}/%{name}/templates/*.tmpl
%{_datadir}/icons/hicolor/*/apps/cups.png
%{_defaultdocdir}/%{name}-%{version}/help/*.html
%{_defaultdocdir}/%{name}-%{version}/images/*.{jpg,gif,png}
%{_defaultdocdir}/%{name}-%{version}/robots.txt
%{_defaultdocdir}/%{name}-%{version}/index.html
%{_defaultdocdir}/%{name}-%{version}/*/index.html
%{_defaultdocdir}/%{name}-%{version}/apple-touch-icon.png
%{_defaultdocdir}/%{name}-%{version}/%{name}*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/%{name}/usb/org.%{name}.usb-quirks
%exclude %{_mandir}/man1/cups-config.1.gz
%{_mandir}/man1/*.1.gz
%{_mandir}/man5/*.5.gz
%{_mandir}/man7/*.7.gz
%{_mandir}/man8/*.8.gz

#-----------------------------------------------------------------------------
%pre
if [ "$1" = 1 ]; then
  getent group %{lpadmin}> /dev/null
  if [ $? -ne 0 ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{lpadmin}
    /usr/sbin/useradd 				\
	-r					\
	-c 'Printers Management User'		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{lpadmin}				\
	-s /sbin/nologin			\
	-d %{_var}/spool/%{name}		\
	%{name}
    fi
  fi

#after upgrade or remove
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1
  %{_sbindir}/chkconfig --del %{name}
  %{_sbindir}/userdel %{name}
  %{_sbindir}/groupdel %{lpadmin}
  gtk-update-icon-cache -t %{_datadir}/icons/hicolor > /dev/null 2>&1
  (
  /usr/bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post
gtk-update-icon-cache -t %{_datadir}/icons/hicolor > /dev/null 2>&1
%{_sbindir}/chkconfig --add %{name}
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null < /dev/null 2>&1

#=============================================================================
%package		libs
Summary		:	CUPS printing system - libraries

%description		libs
CUPS printing system provides a portable printing layer for
UNIX® operating systems. It has been developed by Apple Inc.
to promote a standard printing solution for all UNIX vendors and users.
CUPS provides the System V and Berkeley command-line interfaces.
The cups-libs package provides libraries used by applications to use CUPS
natively, without needing the lp/lpr commands.
 
#-----------------------------------------------------------------------------
%files			libs
%defattr(-,root,root,-)
%{license} LICENSE NOTICE
%{_libdir}/lib%{name}.so.2
%{_libdir}/lib%{name}image.so.2
 
#=============================================================================
%package		devel
Summary		:	Common Unix Printing System - development environment

Requires	:	%{name}-libs	=	%{version}-%{release}
#-----------------------------------------------------------------------------

%description		devel
The Common UNIX Printing System provides a portable printing layer for
UNIX® operating systems. This is the development package for creating
additional printer drivers, and other CUPS services.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_bindir}/%{name}-config
%{_includedir}/%{name}/*.h
%{_libdir}/lib%{name}*.so
%{_libdir}/pkgconfig/%{name}.pc
%{_mandir}/man1/cups-config.1.gz

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

tar xf %{SOURCE1}
 
CC=gcc CXX=g++						\
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--localstatedir=%{_var}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-dbus=yes				\
	--enable-libpaper 				\
	--enable-pam					\
	--enable-raw-printing				\
	--with-dnssd=avahi				\
	--with-system-groups=%{lpadmin}			\
	--with-rcdir="/tmp/cupsinit"			\
	--with-tls=gnutls				\


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}


#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}/tmp/cupsinit
%{__make}							\
	DSTROOT=%{buildroot}					\
	INITDIR=%{_sysconfdir}/rc.d				\
	DOCDIR=%{buildroot}%{_defaultdocdir}/%{name}-%{version}	\
	install

%{__mkdir_p} %{buildroot}%{_var}/spool/%{name}
%{__rm} -fr %{buildroot}%{_sysconfdir}/rc.d/rc*.d

#replacing cups init script by our own
%{__cp} -af							\
	%{name}-ok_addon/%{name}				\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#installing pam.d/cups
%{__mkdir_p}							\
	%{buildroot}%{_sysconfdir}/pam.d
%{__cp} -af							\
	%{name}-ok_addon/%{name}.pam				\
	%{buildroot}%{_sysconfdir}/pam.d/%{name}

#installing configuration file
%{__mv}								\
	%{buildroot}%{_sysconfdir}/%{name}/%{name}d.conf	\
	%{buildroot}%{_sysconfdir}/%{name}/%{name}d.local

%{__cp} -af							\
	%{name}-ok_addon/%{name}d.remote			\
	%{buildroot}%{_sysconfdir}/%{name}/

%{__ln_s}							\
	./%{name}d.local					\
	%{buildroot}%{_sysconfdir}/%{name}/%{name}d.conf
#-----------------------------------------------------------------------------
%changelog
